#tag Class
Protected Class SocketThread
Inherits Thread
	#tag Event
		Sub Run()
		  if mySocket = nil then 
		    mySocket = new StateMachineHTTPSocket
		  end if
		  
		  mySocket.prepare(CLOUD_URL.ToText)
		  if not checkConnection() then
		    break
		  end if
		End Sub
	#tag EndEvent


	#tag Method, Flags = &h0
		Function checkConnection() As boolean
		  mySocket.send("GET", mySocket.baseURL + "/connectionCheck.html")
		  waitForResponse()
		  if mySocket.lastContentReceived = "OK" then 
		    return true
		  end if
		  return false
		  
		  
		  
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub waitForResponse()
		  //This method assumes that we have just send a message to the socket, and we are waiting for a response, or for a timeout.
		  dim start as Integer = Ticks
		  while mySocket.currState = "communicating" and ticks - start < (180 * 60)
		    mySocket.myStatus = "Waiting for the sync socket..."
		    me.Sleep(100)
		  wend
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h0
		CLOUD_URL As String = "https://cloud.miridiatech.com/"
	#tag EndProperty

	#tag Property, Flags = &h0
		mySocket As StateMachineHTTPSocket
	#tag EndProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="CLOUD_URL"
			Group="Behavior"
			InitialValue="""""https://cloud.miridiatech.com/"""""
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			Type="Integer"
			EditorType="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
			EditorType="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Priority"
			Visible=true
			Group="Behavior"
			InitialValue="5"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="StackSize"
			Visible=true
			Group="Behavior"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
			EditorType="String"
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
